'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Spinner = require('../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Spinner dots', function () {
  it('displays a spinner-dots class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { type: 'spinner-dots' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner bounce', function () {
  it('displays a spinner-bounce class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { type: 'spinner-bounce' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner circular', function () {
  it('displays a spinner-circular class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { type: 'spinner-circular' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner with loading true', function () {
  it('has a loading class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: true, type: 'spinner-bounce' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner with fixed position', function () {
  it('has a loading class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: true, type: 'spinner-bounce', position: 'fixed' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner with inline position', function () {
  it('has a loading class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: true, type: 'spinner-bounce', position: 'inline' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner', function () {
  it('has an className', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: true, type: 'spinner-bounce', className: 'testing' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner', function () {
  it('has custom background color', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: true, type: 'spinner-bounce', color: '#3C97D3' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner', function () {
  it('displays an is-hidden class', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: false, type: 'spinner-bounce' }));
    expect(spinner).toMatchSnapshot();
  });
});

describe('Spinner', function () {
  jest.useFakeTimers();

  it('calls a setTimeout when delay is passed', function () {
    var spinner = shallow(_react2.default.createElement(_Spinner2.default, { loading: true, delay: 1000, type: 'spinner-bounce' }));

    expect(setTimeout).toHaveBeenCalledTimes(1);
    expect(setTimeout).toHaveBeenLastCalledWith(expect.any(Function), 1000);
  });
});